config/routes.rb
# Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html
Rails.application.routes.draw do
  resources :merchants, only: %i[show]
  resources :wines, only: %i[index show]

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check

  # Serving wines index as default route
  root to: "wines#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/merchant.rb
class Merchant < ApplicationRecord
  has_many :wine_references, class_name: 'Wine::Reference'

  validates :name, :website, presence: true
end

app/models/wine.rb
# frozen_string_literal: true

class Wine < ApplicationRecord
  YEAR_GTEQ = 1900

  has_many :critic_ratings, -> { order(rating: :desc) }, class_name: 'Wine::CriticRating'
  has_many :references, -> { order(price: :asc) }, class_name: 'Wine::Reference'

  enum color: { red: 'red', white: 'white', rose: 'rose' }

  validates :name, :year, :color, presence: true
  validates :name, uniqueness: { scope: %i[year] }
  validates :year, numericality: { greater_than_or_equal_to: YEAR_GTEQ, less_than_or_equal_to: Date.current.year }

  class << self
    # Return the wines with at least one merchant reference, sorted by the average of critic ratings
    # Can search by minimum/maximum price relative to the minimum price of the references of each wine
    def search(price_min:, price_max:)
      query = Wine.select('wines.id, wines.name, wines.year',
                          'COUNT(wine_critic_ratings.rating) as critic_ratings_count',
                          'AVG(wine_critic_ratings.rating) as critic_ratings_average',
                          'MIN(wine_references.price) as references_min_price')
                  .joins(:references)
                  .left_joins(:critic_ratings)
      query = query.having('references_min_price >= ?', price_min.to_f) if price_min.present?
      query = query.having('references_min_price <= ?', price_max.to_f) if price_max.present?
      query.group('wines.id, wines.name, wines.year')
           .order('critic_ratings_average desc')
    end
  end
end

app/models/wine/critic_rating.rb
class Wine
  class CriticRating < ApplicationRecord
    SCORE_GTEQ = 0
    SCORE_LTEQ = 100

    belongs_to :wine

    validates :wine, :author, :rating, :url, :tasted_at, presence: true
    validates :score, numericality: {
      greater_than_or_equal_to: SCORE_GTEQ,
      less_than_or_equal_to: SCORE_LTEQ
    }
  end
end

app/models/wine/reference.rb
class Wine
  class Reference < ApplicationRecord
    belongs_to :wine
    belongs_to :merchant

    validates :wine, :merchant, :price, :url, presence: true
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/merchants_controller.rb
class MerchantsController < ApplicationController
  def show
    @merchant = merchant
  end

  private

  def merchant
    @merchant ||= Merchant.find(params[:id])
  end
end

app/controllers/wines_controller.rb
# frozen_string_literal: true

class WinesController < ApplicationController
  def index
    wines = Wine.search(price_min: index_params[:price_min], price_max: index_params[:price_max])
    @wines = Kaminari.paginate_array(wines).page(params[:page])
    @params = index_params
  end

  def show
    @wine = wine
  end

  private

  def wine
    @wine ||= Wine.includes([{ references: [:merchant] }, :critic_ratings]).find(params[:id])
  end

  def index_params
    params.permit(:price_min, :price_max)
  end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>EnergieVin</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/merchants/show.html.erb
<h1>
  <%= @merchant.name %>
</h1>

<%= Merchant.human_attribute_name('website') %> : <a href="<%= @merchant.website %>"><%= @merchant.website %></a>
<% if @merchant.description.present? %>
<br><%= Merchant.human_attribute_name('description') %> : <%= @merchant.description %>
<% end %>

<p>
  <%= link_to t('.back'), :back %>
</p>

app/views/wine/critic_ratings/_critic_rating.html.erb
<%= Wine::CriticRating.human_attribute_name('author') %> : <%= critic_rating.author %><br>

<%= Wine::CriticRating.human_attribute_name('rating') %> : <%= critic_rating.rating %>/100<br>

<%= Wine::CriticRating.human_attribute_name('tasted_at') %> : <%= critic_rating.tasted_at.strftime("%d/%m/%Y") %><br>

<%= link_to Wine::CriticRating.human_attribute_name('url'), critic_rating.url %>

<% if critic_rating.review.present? %>
  <br><%= Wine::CriticRating.human_attribute_name('review') %> : <%= critic_rating.review %>
<% end %>

app/views/wine/references/_reference.html.erb
<%= link_to reference.merchant.name, merchant_path(reference.merchant) %><br>

<%= Wine::Reference.human_attribute_name('price') %> : <%= reference.price %> €<br>

<%= link_to t('.view_on_website'), reference.url %>

app/views/wines/index.html.erb
<h1>
  <%= t('.title') %>
</h1>

<%= form_with url: wines_path, method: :get do |form| %>
  <%= form.label(:price_min, t('.price_min')) %>
  <%= form.text_field(:price_min, value: @params[:price_min]) %>
  <%= form.label(:price_max, t('.price_max')) %>
  <%= form.text_field(:price_max, value: @params[:price_max]) %>
  <%= form.submit t('.search') %>
<% end %>

<ul>
  <% @wines.each do |wine| %>
    <li>
      <%= link_to "#{wine.year} #{wine.name}", wine %><br>
      <%= t('.critic_ratings', average: wine.critic_ratings_average&.round, count: wine.critic_ratings_count) %><br>
      <%= t('.references_min_price', price: wine.references_min_price) %>
    </li>
  <% end %>
</ul>

<%= paginate @wines %>

app/views/wines/show.html.erb
<h1>
  <%= @wine.name %>
</h1>

<p>
  <%= Wine.human_attribute_name('year') %> : <%= @wine.year %><br>
  <%= Wine.human_attribute_name('color') %> : <%= Wine.human_attribute_name("color.#{@wine.color}") %>
</p>

<h2>
  <%= t('.references') %>
</h2>

<ul>
  <% @wine.references.each do |wine_reference| %>
  <li>
    <%= render wine_reference %>
  </li>
  <% end %>
</ul>

<h2>
  <%= t('.critic_ratings') %>
</h2>

<ul>
  <% @wine.critic_ratings.each do |wine_critic_rating| %>
    <li>
      <%= render wine_critic_rating %>
    </li>
  <% end %>
</ul>

<%= link_to t('.back'), wines_path %>